#include <client.hpp>
#include <iostream>
#include <ostream>
#include <sstream>
#include <string>

#include "client.hpp"
#include "null_buffer.hpp"

#include "../src/mapstr.hpp"
#include "../src/debug.hpp"

namespace org {
namespace gdb {
namespace rsp {

class bar
{

public:

	std::ostream os;
	std::istringstream is;

	GdbFeature gdb_feature;

	bar()
	:
		os( & null_buffer )
	{
		is.unsetf( std::ios_base::skipws );
	}

	virtual ~bar()
	{
	}

	void foo();
};

void bar::foo() {

	StopReplyType expected_StopReplyType;
	StopReplyType actual_StopReplyType;

	StopReplyPacket r;
	//std::string r;

	std::string msg;
	std::exception_ptr p = nullptr;

	is.str( "+$OK#9a" );

	D() << "instantiating client.." << std::endl;

	client client( is, os );

	D() << "calling reportTargetStatus()" << std::endl;

	try {
		client.reportTargetStatus( r );
	} catch( ... ) {
		p = std::current_exception();
		try {
			std::rethrow_exception( p );
		} catch( std::exception e ) {
			msg = e.what();
		}
	}

	if ( nullptr != p ) {
		D() << "exception was thrown with message '" << msg << "'" << std::endl;
	}

	expected_StopReplyType = g_gdbrsp_constants.STOP_REPLY_OK;
	actual_StopReplyType = r.type;

	if ( expected_StopReplyType != actual_StopReplyType ) {
		D()
			<< "expected: '" << expected_StopReplyType << "' "
			<< "actual: '" << actual_StopReplyType << "'"
			<< std::endl;
	}
}

} /* namespace rsp */
} /* namespace gdb */
} /* namespace org */

int main() {
	org::gdb::rsp::bar b;

	b.foo();

	return 0;
}
