#include <cstdio>
#include <iomanip>
#include <sstream>

#include "debug.hpp"
#include "hexstr.hpp"

namespace org {
namespace gdb {
namespace rsp {

std::string hexstr::decode( const std::string & src ) {

	std::stringstream r;

	std::string ss;

	//D() << "input is '" << src << "'" << std::endl;

	for( auto & u8: get_bytes( src ) ) {
		r << (char) u8;
	}

	//D() << "output is '" << r.str() << "'" << std::endl;

	return r.str();
}

std::string hexstr::encode( const std::string & src ) {
	std::stringstream r;

	//D() << "input is '" << src << "'" << std::endl;

	for( auto & c: src ) {
		r << std::hex << std::setfill('0') << std::setw(2) << (int)c;
	}

	//D() << "output is '" << r.str() << "'" << std::endl;

	return r.str();
}

std::vector<uint8_t> hexstr::get_bytes( const std::string & src ) {

	std::vector<uint8_t> r;

	std::string ss;
	int x;

	for( size_t i = 0; i < src.size() && i + 1 < src.size(); i += 2 ) {
		ss = src.substr( i, 2 );
		std::sscanf( ss.c_str(), "%02x", & x );
		r.push_back( (char) x );
	}

	return r;
}
uint8_t hexstr::get_byte( const std::string & src ) {
	std::vector<uint8_t> rr = get_bytes( src );
	return 0 == rr.size() ? -1 : rr[ 0 ];
}

} /* namespace rsp */
} /* namespace gdb */
} /* namespace org */
