#ifndef SRC_MAPSTR_HPP_
#define SRC_MAPSTR_HPP_

#include <map>
#include <ostream>
#include <sstream>
#include <string>

template <class K, class V>
std::string map2str( const std::map<K,V> & m ) {
	std::stringstream ss;

	ss << "{";
	size_t i = 0;
	for( auto & kv: m ) {
		if ( 0 == i ) {
			ss << " ";
		}
		ss << "( " << kv.first << ", " << kv.second << " )";
		if ( i < m.size() - 1 ) {
			ss << ", ";
		}
		if ( i == m.size() - 1 ) {
			ss << " ";
		}
		i++;
	}
	ss << "}";

	return ss.str();
}

template <class K, class V>
std::ostream & operator<<( std::ostream & os, const std::map<K,V> & m ) {
	os << map2str( m );
	return os;
}

#endif /* SRC_MAPSTR_HPP_ */
