#ifndef SRC_PAIRSTR_HPP_
#define SRC_PAIRSTR_HPP_

#include <ostream>
#include <sstream>
#include <string>
#include <utility>

template <class K, class V>
std::string pair2str( const std::pair<K,V> & p ) {
	std::stringstream ss;
	ss << "( " << p.first << ", " << p.second << " )";
	return ss.str();
}

template <class K, class V>
std::ostream & operator<<( std::ostream & os, const std::pair<K,V> & p ) {
	os << pair2str( p );
	return os;
}

#endif /* SRC_PAIRSTR_HPP_ */
