#ifndef SRC_VECSTR_HPP_
#define SRC_VECSTR_HPP_

#include <ostream>
#include <sstream>
#include <string>
#include <vector>

template <class T>
std::string vec2str( const std::vector<T> & v ) {
	std::stringstream ss;

	ss << "[";
	for( size_t i = 0; i < v.size(); i++ ) {
		if ( 0 == i ) {
			ss << " ";
		}
		ss << v[ i ];
		if ( i < v.size() - 1 ) {
			ss << ", ";
		}
		if ( i == v.size() - 1 ) {
			ss << " ";
		}
	}
	ss << "]";

	return ss.str();
}

template <class T>
std::ostream & operator<<( std::ostream & os, const std::vector<T> & v ) {
	os << vec2str( v );
	return os;
}

#endif /* SRC_VECSTR_HPP_ */
